//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TColorForm *ColorForm;

//---------------------------------------------------------------------------
__fastcall TColorForm::TColorForm(TComponent* Owner)
	: TForm(Owner)
{
    ComboBoxStoreSettings->ItemIndex = 0;
    ComboBoxDateFormat->ItemIndex = MainForm->dateFormat;
    ComboBoxDaysInAdvance->ItemIndex = MainForm->daysInAdvance-1;
}

//---------------------------------------------------------------------------
void __fastcall TColorForm::FormClick(TObject *Sender)
{
   ColorDialog1->Color = MainForm->Color;
   if (!ColorDialog1->Execute()) return;
   MainForm->Color = ColorDialog1->Color;
}
//---------------------------------------------------------------------------
void TColorForm::SetEdit(TColor Color)
{
   for (int i=0; i<(MainForm->ComponentCount); i++)
      if (dynamic_cast<TEdit *>(MainForm->Components[i]))
      {
         if (dynamic_cast<TEdit *>(MainForm->Components[i])->ReadOnly == false)
             dynamic_cast<TEdit *>(MainForm->Components[i])->Color = Color;
      }
      else if (dynamic_cast<TComboBox *>(MainForm->Components[i]))
         dynamic_cast<TComboBox *>(MainForm->Components[i])->Color = Color;
}

void __fastcall TColorForm::EditClick(TObject *Sender)
{
   ColorDialog1->Color = MainForm->NameEdit->Color;
   if (!ColorDialog1->Execute()) return;
   SetEdit(ColorDialog1->Color);
}
//---------------------------------------------------------------------------
void TColorForm::SetEditText(TFont * Font)
{
   for (int i=0; i<(MainForm->ComponentCount); i++)
      if (dynamic_cast<TEdit *>(MainForm->Components[i]))
      {
         dynamic_cast<TEdit *>(MainForm->Components[i])->Font->Charset = Font->Charset;
         dynamic_cast<TEdit *>(MainForm->Components[i])->Font->Color = Font->Color;
         dynamic_cast<TEdit *>(MainForm->Components[i])->Font->Name = Font->Name;
         dynamic_cast<TEdit *>(MainForm->Components[i])->Font->Size = Font->Size;
      }
      else if (dynamic_cast<TComboBox *>(MainForm->Components[i]))
      {
         dynamic_cast<TComboBox *>(MainForm->Components[i])->Font->Charset = Font->Charset;
         dynamic_cast<TComboBox *>(MainForm->Components[i])->Font->Color = Font->Color;
         dynamic_cast<TComboBox *>(MainForm->Components[i])->Font->Name = Font->Name;
         dynamic_cast<TComboBox *>(MainForm->Components[i])->Font->Size = Font->Size;
      }
}

void __fastcall TColorForm::EditTextClick(TObject *Sender)
{
   FontDialog1->Font = MainForm->NameEdit->Font;
   if (!FontDialog1->Execute()) return;
   SetEditText(FontDialog1->Font);
}
//---------------------------------------------------------------------------
void __fastcall TColorForm::Label1Click(TObject *Sender)
{
   ColorDialog1->Color = MainForm->Label1->Font->Color;
   if (!ColorDialog1->Execute()) return;
   MainForm->Label1->Font->Color = ColorDialog1->Color;
}
//---------------------------------------------------------------------------
void __fastcall TColorForm::Label2Click(TObject *Sender)
{
   ColorDialog1->Color = MainForm->Label2->Font->Color;
   if (!ColorDialog1->Execute()) return;
   MainForm->Label2->Font->Color = ColorDialog1->Color;
}
//---------------------------------------------------------------------------
void TColorForm::SetLabels(TColor Color)
{
   TColor Color1 = MainForm->Label1->Font->Color,
          Color2 = MainForm->Label2->Font->Color;
   for (int i=0; i<(MainForm->ComponentCount); i++)
      if (dynamic_cast<TLabel *>(MainForm->Components[i]))
         dynamic_cast<TLabel *>(MainForm->Components[i])->Font->Color = Color;
   MainForm->Label1->Font->Color = Color1;
   MainForm->Label2->Font->Color = Color2;
}

void __fastcall TColorForm::LabelsClick(TObject *Sender)
{
   ColorDialog1->Color = MainForm->Label3->Font->Color;
   if (!ColorDialog1->Execute()) return;
   SetLabels(ColorDialog1->Color);
}
//---------------------------------------------------------------------------
void __fastcall TColorForm::OKClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TColorForm::DefaultClick(TObject *Sender)
{
   MainForm->Color = MainForm->formColor;
   SetEdit(MainForm->editColor);
   MainForm->Label1->Font->Color = MainForm->label1Color;
   MainForm->Label2->Font->Color = MainForm->label2Color;
   SetLabels(MainForm->labelsColor);
   SetEditText(MainForm->editFont);
}
//---------------------------------------------------------------------------
void __fastcall TColorForm::SaveClick(TObject *Sender)
{
   // Saving colors in registry
   TCustomIniFile * IniFile;

   if (ComboBoxStoreSettings->ItemIndex == 0)
        IniFile = new TIniFile(".\\Birthday.ini");
   else
        IniFile = new TRegistryIniFile("SOFTWARE\\Birthday Scanner");

   IniFile->WriteInteger("Colors","Form",MainForm->Color);
   IniFile->WriteInteger("Colors","Edit",MainForm->NameEdit->Color);
   IniFile->WriteInteger("Colors","EditText",MainForm->NameEdit->Font->Color);
   IniFile->WriteInteger("Colors","Label1",MainForm->Label1->Font->Color);
   IniFile->WriteInteger("Colors","Label2",MainForm->Label2->Font->Color);
   IniFile->WriteInteger("Colors","Labels",MainForm->Label3->Font->Color);
   IniFile->WriteString ("Fonts","Name",MainForm->NameEdit->Font->Name);
   IniFile->WriteInteger("Fonts","Charset",MainForm->NameEdit->Font->Charset);
   IniFile->WriteInteger("Fonts","Size",MainForm->NameEdit->Font->Size);
   IniFile->WriteInteger("General","Settings",ComboBoxStoreSettings->ItemIndex);
   IniFile->WriteInteger("General","DateFormat",MainForm->dateFormat);
   IniFile->WriteInteger("General","DefaultRemind",MainForm->daysInAdvance);
   IniFile->Free();
}

void __fastcall TColorForm::ComboBoxDateFormatChange(TObject *Sender)
{
    MainForm->dateFormat = ComboBoxDateFormat->ItemIndex;
    ShortDateFormat = ComboBoxDateFormat->Text;
    DateSeparator = ShortDateFormat[2];
}
//---------------------------------------------------------------------------

void __fastcall TColorForm::ComboBoxDaysInAdvanceChange(TObject *Sender)
{
    MainForm->daysInAdvance = ComboBoxDaysInAdvance->ItemIndex + 1;
}
//---------------------------------------------------------------------------

